/*
 * Jacek Lysiak
 *
 * AlienOS program emulator
 * 
 * `emu` starts `loader` which reads given ELF 
 * file and runs AlienOS code.
 * `loader` is traced by `emu` using ptrace.
 * Tracee is stopped on each entry to syscall. 
 * Then, tracer reads syscall args,
 * skip tracee instruction and sets its 
 * registers to simulate syscall result.
 * 
 * NOTICE: For secutiry reasons, 
 * alien program has allocated new
 * small fixed stack of 4MB at 0x80400000.
 * It won't grow down (GROWSDOWN flag is cleared).
 * We want to let alienOS program pass
 * pointers to its stack but we also
 * must have this under control.
 * 
 */

#define _POSIX_SOURCE           // req. for: raise

#include <sys/user.h>
#include <sys/ptrace.h>
#include <sys/ioctl.h>
#include <linux/ptrace.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <signal.h>

#include "alienos_term.h"
#include "alienos_elf.h"
#include "read_elf.h"
#include "proc_utils.h"
#include "screen.h"
#include "err.h"
#include "emulator.h"
#include "emu.h"

static void run_loader(char **argv) 
{
    // loader is doing execv and loads AlienOS program.
    SYSERR(ptrace(PTRACE_TRACEME, 0, NULL, NULL) < 0, "ptrace");
    raise(SIGSTOP);
    execv(LOADER_FILE, argv);   // Don't care about argv[0]
    SYSERR(1, "execv failed on loader startup");
}

static int run_emu(pid_t pid, long entry)
{
    RETERR(wait_proc(pid, SIGSTOP) < 0);
    RETERRMSG(ptrace(PTRACE_CONT, pid, NULL, NULL) < 0, "PTRACE_CONT");
    // We're catching first SIGTRAP from execv then
    // we expect that SIGSTOP will be sent just before jumping
    // into alien's code...
    RETERR(wait_proc(pid, SIGTRAP) < 0);
    RETERRMSG(ptrace(PTRACE_SETOPTIONS, pid, NULL, PTRACE_O_EXITKILL) < 0, "PTRACE SET OPT");
    RETERRMSG(ptrace(PTRACE_CONT, pid, NULL, NULL) < 0, "PTRACE_CONT");
    RETERR(wait_proc(pid, SIGSTOP) < 0);
    // Loader is ready to jump. Now change stack address
    // and set entry point.
    // We do not validate entry point address here because
    // it's checked by loader before raising SIGSTOP
    struct user_regs_struct regs;
    RETERRMSG(ptrace(PTRACE_GETREGS, pid, NULL, &regs) < 0, "ptrace get regs");
    regs.rsp = STACK_ADDR + STACKSZ - 8;
    regs.rip = entry;
    RETERRMSG(ptrace(PTRACE_SETREGS, pid, NULL, &regs) < 0, "ptrace set regs");
    ascr_init();
    RETERRMSG(ptrace(PTRACE_SYSEMU, pid, NULL, NULL) < 0, "PTRACE_SYSEMU");
    return emu_main(pid);
}

int main(int argc, char **argv)
{
    if (argc < 2) {
        printf(USAGE, argv[0]);
        exit(EXIT_SUCCESS);
    }
    struct winsize w;
    SYSERR(ioctl(STDOUT_FILENO, TIOCGWINSZ, &w) < 0, "ioctl");
    EMUERR(w.ws_row < TERM_H || w.ws_col < TERM_W, "Too small terminal!");

    Elf64_Ehdr ehdr;
    int fd = open(argv[1], O_RDONLY);
    SYSERR(fd < 0, "opening ELF file");
    SYSERR(read_elf_hdr(fd, &ehdr) < 0, "read elf err");
    SYSERR(close(fd) < 0, "closing ELF file");

    pid_t pid = fork();
    SYSERR(pid < 0, "fork");
    
    if (pid == 0)
        run_loader(argv);

    // Parent goes here...
    // After ncurses init we must back from `run_emu`.
    // `run_emu` returns:
    //   - exit code generated by AlienOS program emulation: 
    //      * correct exit: 0 - 63
    //      * fault detected: 127
    //   - emulator errors: -1 (EMU_ERR)
    int ecode = run_emu(pid, ehdr.e_entry);
    ascr_end();
    if (ecode == RET_ERR || ECODE(ecode) == FAULT_ECODE)
        SHOW_ERR_MSG();
    return ecode;
}

